#!/usr/bin/perl -w
#
# AGHA v2.1 -- October, 2005
# Another gay habbo application!
#
# Successfully tested on WindozeXP; Perl 5.8.7 .
# Successfully tested on Linux 2.6.10; Perl 5.8.6 .
#
# This script focusses on packet display rather than packet editing.
# Place all plug-ins in the client or server folder with any extension. The
# available variables from within a plug-in are:
#
# $iocurrent	=	Current socket;
# $ioclient	=	Socket connected to client;
# $ioserver	=	Socket connected to server;
# $iolib	=	Socket library holding both $ioclient and $ioserver;
# $buffer	=	Holds the current data in queue;
# $plugin	=	The name of the current plug-in;
# $SETTINGS	=	Holds all application wide settings.
#
# by knights199
#
###############################################################################

# Import some modules we'll need.

    use strict;
    use IO::Socket;
    use IO::Select;
    use LWP::Simple;
    use FindBin qw/$Bin/;
    use Term::ReadKey qw/GetTerminalSize/;
    if($^O eq "MSWin32"){
        require Win32::Console::ANSI;
        Win32::Console::ANSI->import;

        require Win32::Process;
        Win32::Process->import;
    }

our($SETTINGS) = dosettings();

#$SIG{INT} = sub {
#    disp("*** EXITING ***") if($SETTINGS->{verbose});
#    exit(0);
#};

main();

sub disp{
    my($w)   = GetTerminalSize();
    my($msg) = shift;
    $w /= 2;
    $w -= length($msg)/2;
    print(" "x$w);
    print("$msg\n");
}

sub err{
    my($msg) = shift;
    disp($msg);
    if(open(ERR,">>error.log")){
        print(ERR "[",scalar(localtime()),"]: $msg\n");
        close(ERR);
        disp("*** WROTE ERROR LOGFILE ***");
    }
    else{ disp("*** UNABLE TO WRITE ERROR LOGFILE ***"); }
    exit(0);
}

sub help{
    print(<<EOF);

Usage:
	\$ $0 <options>

Options:
	-l		=	Enable logfile
	-V		=	Verbose mode
	-T		=	Enable a live datalog on terminal
	-s		=	Decide to scan for plugins
	-b <path|cmd>	=	Choose the browser to load
	-h		=	Display this menu
	-h <hotel>	=	Change hotel to load
				Example: -h .com
	-t <texts>	=	Set the external texts to use
	-v <vars>	=	Set the external variables to use
	-p <port>	=	Specify a localport to listen on
	-c <client>	=	Specify the director file to use

EOF
    print("Colortable:\n");
    $SETTINGS ||= shift;
    foreach(keys %{$SETTINGS->{colors}}){
        print("\t");
        print("0x".unpack("H*",$_));
        print("\t\t=\t");
	print($SETTINGS->{colors}->{$_});
        print("\n");
    }
    exit(0);
}

sub dosettings{
    my($opt);
    if(!($opt = do('settings.ini'))){
        err("*** CAN'T LOAD SETTINGS FILE ***");
    }
    else{
        for(my($i) = 0; $i < @ARGV; $i++){
            my($key) = $ARGV[$i];
            if   ($key eq "-l"){ $opt->{logfile}   = 1;                       }
            elsif($key eq "-V"){ $opt->{verbose}   = 1;                       }
            elsif($key eq "-T"){ $opt->{termlog}   = 1;                       }
            elsif($key eq "-s"){ $opt->{scanplugin}= 1;                       }
            elsif($key eq "-b"){ $opt->{browser}   = $ARGV[++$i];             }
            elsif($key eq "-t"){ $opt->{texts}     = $ARGV[++$i];             }
            elsif($key eq "-v"){ $opt->{vars}      = $ARGV[++$i];             }
            elsif($key eq "-p"){ $opt->{clientport}= $ARGV[++$i];             }
            elsif($key eq "-c"){ $opt->{client}    = $ARGV[++$i];             }
            elsif($key eq "-h"){ ($opt->{hotel}    = $ARGV[++$i])||help($opt);}
            else { help($opt); }
        }
        return($opt);
    }
}

sub getcid{
    local($^W) = undef;
    help() if(!defined($SETTINGS->{hotel}));
    my($cid) = map{ m/\?t=(\d{13,})/ }
    get("http://".$SETTINGS->{web}.$SETTINGS->{hotel});
    if(defined($cid)){
        disp("*** CALLER ID IS $cid ***") if($SETTINGS->{verbose});
        return $cid;
    }
    else{
        disp("*** NO CALLER ID FOUND ***") if($SETTINGS->{verbose});
        return(0);
    }
}

sub getfile{
    my($io_socket) =
        IO::Socket::INET->new($SETTINGS->{web}.$SETTINGS->{hotel}.":80") ||
        err("*** CAN'T CONNECT TO DOMAIN $SETTINGS->{hotel} ***");
    print($io_socket "GET / HTTP/1.0\r\n\r\n");
    my($url) = map{ m/(?<=$SETTINGS->{web}$SETTINGS->{hotel})(\S+)/ }
        <$io_socket>;
    $url ||= "/habbo/".$1."/" if($SETTINGS->{hotel} =~ m/^\.(.+)$/);
    disp("*** REDIRECTED TO $url ***") if($SETTINGS->{verbose});

    $io_socket = IO::Socket::INET->new($SETTINGS->{web}.$SETTINGS->{hotel}.
    ":80") || err("*** CAN'T CONNECT ON DOMAIN $SETTINGS->{hotel} ***");
    print($io_socket "GET $url"."common/habbo_client/client_popup".
    ($SETTINGS->{cid} ? "/?t=$SETTINGS->{cid}" : "/")." HTTP/1.0\r\n\r\n");

    open(FILE,">./tmp.html") || err("*** ERROR OPENING HTML FILE ***");
    my(@tmp) = <$io_socket>;
    close($io_socket);
    shift(@tmp) while($tmp[0] !~ m/^</);
    foreach(@tmp){ print(FILE $_) if(!(m/^\s*$/)) }
    if (-f "./tmp.html"){
        disp("*** FETCHED HTML FILE ***") if($SETTINGS->{verbose});
        return(1);
    }
    else{ return(0); }
}

sub editfile{
    open(FILE,"./tmp.html") || err("*** ERROR OPENING HTML FILE ***");
    local($/) = undef;
    my($tmp) = <FILE>;
    close(FILE);

    ($SETTINGS->{serverport}) = $tmp =~ m/(?<=connection\.info\.port=)([^\"]+)/;
    ($SETTINGS->{serverhost}) = $tmp =~ m/(?<=connection\.info\.host=)([^\"]+)/;
    $SETTINGS->{clientport} ||= ($SETTINGS->{serverport} + 2);

    if($SETTINGS->{texts}){
        $tmp =~ s/(?<=external\.texts\.txt=)[^\"]+/$SETTINGS->{texts}/g;
    }
    if($SETTINGS->{vars}){
        $tmp =~ s/(?<=external\.variables\.txt=)[^\"]+/$SETTINGS->{vars}/g;
    }
    if($SETTINGS->{client}){
        $tmp =~ s/(?<=\")[^\"]+?dcr[^\"]+/$SETTINGS->{client}/g;
    }
    if($SETTINGS->{verbose}){
        disp("*** SERVER HOST IS $SETTINGS->{serverhost} ***");
        disp("*** SERVER PORT IS $SETTINGS->{serverport} ***");
        disp("*** CLIENT PORT IS $SETTINGS->{clientport} ***");
    }

    $tmp =~ s/(?<=connection\.info\.port=)[^\"]+/$SETTINGS->{clientport}/g;
    $tmp =~ s/(?<=connection\.info\.host=)[^\"]+/127.0.0.1/g;

    my($rd) = $Bin;
    $rd =~ s#[/\\]+#$SETTINGS->{dir}#g;
    $rd .= $SETTINGS->{dir} if($rd !~ m/$SETTINGS->{dir}$/);
    $tmp =~ s|(?<=client\.reload\.url=)[^\"]+|"file://".$rd."tmp.html"|eg;

    open(FILE,">./tmp.html") || err("*** ERROR OPENING HTML FILE ***");
    print(FILE $tmp);
    close(FILE);
    return(-f "./tmp.html");
}

sub launchbrowser{
    my($pid);
    my($dir) = $Bin;
    $dir =~ s#[/\\]+#$SETTINGS->{dir}#g;
    $dir .= $SETTINGS->{dir} if($dir !~ m/$SETTINGS->{dir}$/);
    if($^O eq "MSWin32"){
        Win32::Process::Create($pid,
            $SETTINGS->{browser},
            $SETTINGS->{clquote}.$SETTINGS->{browser}.$SETTINGS->{clquote}.
            " ".$dir."tmp.html",
            0,
            0,
            $dir) || err("*** CAN'T START BROWSER ***");
        $SETTINGS->{pid} = $pid;
    }
    else{
        if(!defined($pid = fork())){
            err("*** CAN'T FORK ***");
        }
        elsif($pid == 0){
            exec($SETTINGS->{browser}." file://".$dir."tmp.html") &&
            err("*** CAN'T START BROWSER ***");
        }
    }
    disp("*** LAUNCHED BROWSER ***") if($SETTINGS->{verbose});
    return(1);
}

sub datain{
    my($data) = shift;
    if($SETTINGS->{logfile}){
        if(open(DATAIN,">>data.log")){
            print(DATAIN "[ << \@ ".scalar(localtime())." ]:\n$data\n\n");
            close(DATAIN);
        }
        else{
            disp("*** CAN'T WRITE DATALOG ***");
            $SETTINGS->{logfile} = 0;
        }
    }
    if($SETTINGS->{termlog}){
        $data =~ s/$_/$SETTINGS->{colors}->{$_}/g
            foreach (keys %{$SETTINGS->{colors}});
        print("\n\e[32;1m<<<<\e[m\n");
        print($data."\n");
    }
}

sub dataout{
    my($data) = shift;
    if($SETTINGS->{logfile}){
        if(open(DATAIN,">>data.log")){
            print(DATAIN "[ >> \@ ".scalar(localtime())." ]:\n$data\n\n");
            close(DATAIN);
        }
        else{
            disp("*** CAN'T WRITE DATALOG ***");
            $SETTINGS->{logfile} = 0;
        }
    }
    if($SETTINGS->{termlog}){
        print("\n\e[31;1m>>>>\e[m\n");
        print($data."\n");
    }
}

sub startconnection{
    our($ioserver,$ioclient,$iolib);
    $ioclient = IO::Socket::INET->new(
        LocalAddr	=>	'127.0.0.1',
        LocalPort	=>	$SETTINGS->{clientport},
        Proto		=>	'tcp',
        Listen		=>	1,
        Reuse		=>	1,
    ) || err("*** $! ***");
    $ioclient = $ioclient->accept();
    disp("*** CONNECTED TO CLIENT ***") if($SETTINGS->{verbose});

    $ioserver = IO::Socket::INET->new(
        $SETTINGS->{serverhost}.":".$SETTINGS->{serverport})
    || err("*** CAN'T CONNECT TO SERVER ***");
    disp("*** CONNECTED TO SERVER ***") if($SETTINGS->{verbose});

    $iolib = IO::Select->new();
    $iolib->add($ioserver);
    $iolib->add($ioclient);

    my(@ready);
    our($buffer,$iocurrent,$plugin);
    while(@ready = $iolib->can_read()){
        foreach $iocurrent(@ready){
            if($iocurrent == $ioserver){
                {
                    local($/) = pack("H*",$SETTINGS->{termchar});
                    $buffer = <$iocurrent>;
                }
                if(!$buffer){
                    foreach($iolib->handles()){
                        close($_);
                        $iolib->remove($_);
                    }
                    return;
                }
                foreach $plugin(keys %{$SETTINGS->{plugins}->{server}}){
                    eval($SETTINGS->{plugins}->{server}->{$plugin});
                    print("Error at $plugin:\n".$@) if($@);
                }
                datain($buffer);
                print($ioclient $buffer);
            }
            else{
                sysread($ioclient,$buffer,1024);
                if(!$buffer){
                    foreach($iolib->handles()){
                        close($_);
                        $iolib->remove($_);
                    }
                    return;
                }
                foreach $plugin(keys %{$SETTINGS->{plugins}->{client}}){
                    eval($SETTINGS->{plugins}->{client}->{$plugin});
                    print("Error at $plugin:\n".$@) if($@);
                }
                dataout($buffer);
                print($ioserver $buffer);
            }
        }
    }
}

sub scanplugins{
    my($plugin,$direction);
    foreach $plugin(<./subs/*>){
        local($^W) = 0;
        eval{ do($plugin); };
        print("Error at $plugin:\n".$@) if($@);
    }
    foreach $direction("client","server"){
        foreach $plugin(<./$direction/*>){
	        open(PLUGIN,$plugin) || next;
            $plugin =~ s|^.*/||g;
            $SETTINGS->{plugins}->{$direction}->{$plugin} = join("",<PLUGIN>);
        }
    }
    disp("*** SCANNED FOR PLUGINS ***") if($SETTINGS->{verbose});
    return(1);
}

sub main{
    $SETTINGS->{cid} = getcid();
    if(getfile() && editfile() && launchbrowser()){
        scanplugins() if($SETTINGS->{scanplugin});
        while(1){ startconnection(); disp("*** CONNECTION CLOSED ***"); }
    }
    disp("*** EXITING ***") if($SETTINGS->{verbose});
}

sub END{
    if($^O eq "MSWin32" && $SETTINGS->{pid}){
        $SETTINGS->{pid}->Kill(0);
        disp("*** KILLED BROWSER ***") if($SETTINGS->{verbose});
    }
    unlink("./tmp.html") &&
    disp("*** REMOVED TEMPORARY HTML FILE ***") if($SETTINGS->{verbose});
}
