-- Database schema for FuseLight

-- v0.5: Aapo Kyrl / Jani Lepisto	


CREATE TABLE fuse_user (
    id 				INT AUTO_INCREMENT PRIMARY KEY,
    loginname 	  	VARCHAR(15) NOT NULL,
    password 		VARCHAR(10) NOT NULL,
    figure  		VARCHAR(10) NOT NULL,
    sex 			VARCHAR(1),
    firstname 		VARCHAR(25),
    lastname 		VARCHAR(40),
    phone 			VARCHAR(15),
    email 			VARCHAR(60),
    address 		VARCHAR(40),
    city 			VARCHAR(30),
    zipcode 		VARCHAR(7),
    age 			INTEGER,
    extra 			VARCHAR(100),
    created			DATETIME NOT NULL,
    updated			TIMESTAMP
);


CREATE TABLE user_params (
    user_id 		INTEGER NOT NULL,
    par_type_id  		INTEGER NOT NULL,
    value			VARCHAR(200),
    PRIMARY KEY(user_id, par_type_id)
);


CREATE TABLE par_type (
    id 				INTEGER PRIMARY KEY,
    name	 		VARCHAR(200)
);

-- example how to add a custom param type
insert into par_type values(10, 'custom_param');
insert into par_type values(2, 'last_access_time'); 

CREATE TABLE access (
    id 			INT AUTO_INCREMENT PRIMARY KEY,
    date 			DATETIME NOT NULL,
    user_id 		INTEGER NOT NULL,
    ip	 		VARCHAR(16) NOT NULL,
    domain 			VARCHAR(30),
    logout_time 		DATETIME NOT NULL
);


